/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.hadoop.hbase.snapshot;

import org.apache.yetus.audience.InterfaceAudience;
import org.apache.hadoop.hbase.client.SnapshotDescription;

/**
 * Thrown when a snapshot exists but should not
 */
@SuppressWarnings("serial")
@InterfaceAudience.Public
public class SnapshotExistsException extends HBaseSnapshotException {
  public SnapshotExistsException(String msg) {
    super(msg);
  }

  /**
   * Failure due to the snapshot already existing
   * @param msg full description of the failure
   * @param desc snapshot that was attempted
   */
  public SnapshotExistsException(String msg, SnapshotDescription desc) {
    super(msg, desc);
  }
}
